前言

学习资料来源runoob

列表

  • 序列是 Python 中最基本的数据结构
  • 序列中的每个值都有索引,从0开始。
  • Python 有 6 个序列的内置类型,但最常见的是列表和元组
  • 列表都可以进行的操作包括索引,切片,加,乘,检查成员
  • 内置确定序列的长度以及确定最大最小的元素的方法
  • 列表最常用的 Python 数据类型,可嵌套
  • 列表支持反向索引,访问区间左闭右开
  • 列表的数据项不要求相同类型
  • 创建一个列表,只要把逗号分隔的不同的数据项使用方括号括起来即可。如下所示:
1
2
3
4
5
6

list1 = ['Google', 'Runoob', 1997, 2000]
list2 = [1, 2, 3, 4, 5 ]
list3 = ["a", "b", "c", "d"]
list4 = ['red', 'green', 'blue', 'yellow', 'white', 'black']


更新列表

可以对列表的数据项进行修改或更新,你也可以使用 append() 方法来添加列表项,如下所示:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
#!/usr/bin/python3

list = ['Google', 'Runoob', 1997, 2000]

print ("第三个元素为 : ", list[2])
list[2] = 2001 #这里要区别元组,元组是名称相同,赋值是本质是创建新元组,本质上内存不同
print ("更新后的第三个元素为 : ", list[2])

list1 = ['Google', 'Runoob', 'Taobao']
list1.append('Baidu')
print ("更新后的列表 : ", list1)

#输出
第三个元素为 : 1997
更新后的第三个元素为 : 2001
更新后的列表 : ['Google', 'Runoob', 'Taobao', 'Baidu']

删除列表元素

1
2
3
4
5
6
7
8
9
10
11
12

#!/usr/bin/python3

list = ['Google', 'Runoob', 1997, 2000]

print ("原始列表 : ", list)
del list[2]
print ("删除第三个元素 : ", list)

#输出
原始列表 : ['Google', 'Runoob', 1997, 2000]
删除第三个元素 : ['Google', 'Runoob', 2000]
  • 另外,remove() 方法也可以删除,在后面详细讨论

列表的脚本操作

列表对 + 和 * 的操作符与字符串相似。+ 号用于组合列表,* 号用于重复列表。

Python 表达式 结果 描述
len([1, 2, 3]) 3 长度
[1, 2, 3] + [4, 5, 6] [1, 2, 3, 4, 5, 6] 组合
[‘Hi!’] * 4 [‘Hi!’, ‘Hi!’, ‘Hi!’, ‘Hi!’] 重复
3 in [1, 2, 3] True 元素是否存在于列表中
for x in [1, 2, 3]: print(x, end=” “) 1 2 3 迭代

截取 & 拼接

和元组一样,支持L[1:]写法,截取索引从1开始到最后所有元素

1
2
3
4
5
>>>squares = [1, 4, 9, 16, 25] 
>>> squares += [36, 49, 64, 81, 100]
>>> squares
[1, 4, 9, 16, 25, 36, 49, 64, 81, 100]
>>>

嵌套

1
2
3
4
5
6
7
8
9
10
11

>>>a = ['a', 'b', 'c']
>>> n = [1, 2, 3]
>>> x = [a, n]
>>> x
[['a', 'b', 'c'], [1, 2, 3]]
>>> x[0]
['a', 'b', 'c']
>>> x[0][1]
'b'


内置函数 & 方法

序号 函数
1 len(list) 列表元素个数
2 max(list) 返回列表元素最大值
3 min(list) 返回列表元素最小值
4 list(seq) 将元组转换为列表
序号 方法
1 list.append(obj) 在列表末尾添加新的对象
2 list.count(obj) 统计某个元素在列表中出现的次数
3 list.extend(seq) 在列表末尾一次性追加另一个序列中的多个值(用新列表扩展原来的列表)
4 list.index(obj) 从列表中找出某个值第一个匹配项的索引位置
5 list.insert(index, obj) 将对象插入列表
6 [list.pop(index=-1]) 移除列表中的一个元素(默认最后一个元素),并且返回该元素的值
7 list.remove(obj) 移除列表中某个值的第一个匹配项
8 list.reverse() 反向列表中元素
9 list.sort( key=None, reverse=False) 对原列表进行排序
10 list.clear() 清空列表
11 list.copy() 复制列表

元组

  • Python的元组与列表类似,不同之处在于元组的元素不能修改。
  • 元组使用小括号,列表使用方括号。
  • 元组创建很简单,只需要在括号中添加元素,并使用逗号隔开即可。
  • 元组与字符串类似,下标索引从0开始,可以进行截取,组合等。

如:

1
2
3
4
5
6
7
8
9
10
11
12
>>>tup0 = () #空元组
>>>tup1 = ('physics', 'chemistry', 1997, 2000)
>>>tup2 = (1, 2, 3, 4, 5 )
>>>tup3 = "a", "b", "c", "d" # 不需要括号也可以
>>> type(tup3)
<class 'tuple'>
>>>tup4 = (50,) #元组中只包含一个元素时,需要在元素后面添加逗号,否则括号会被当作运算符使用:
>>> tup5 = (50)
>>> type(tup4) # 加上逗号,类型为元组
<class 'tuple'>
>>> type(tup5) # 不加逗号,类型为整型
<class 'int'>

访问 & 截取

  • 下标索引访问元组中的值,有正向索引和反向索引

    image-20210717211758961

1
2
3
4
5
6
7
8
9
10
11
12
13
14

#!/usr/bin/python3

tup1 = ('Google', 'Runoob', 1997, 2000)
tup2 = (1, 2, 3, 4, 5, 6, 7 )

print ("tup1[0]: ", tup1[0])
print ("tup1[1:]: ", tup1[1:])
print ("tup2[1:5]: ", tup2[1:5]) #左闭右开

#输出
tup1[0]: Google
tup1[1:]: Runoob 1997 2000
tup2[1:5]: (2, 3, 4, 5)

修改

  • 元组中的元素值不允许修改,但元组可以进行连接组合,如下实例:
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15

#!/usr/bin/python3

tup1 = (12, 34.56)
tup2 = ('abc', 'xyz')

# 以下修改元组元素操作是非法的。
# tup1[0] = 100

# 创建一个新的元组
tup3 = tup1 + tup2
print (tup3)

#输出
(12, 34.56, 'abc', 'xyz')

删除

  • 元组中的元素值不允许删除,但我们可以用del语句删除整个元组,如下实例:
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16

#!/usr/bin/python3

tup = ('Google', 'Runoob', 1997, 2000)

print (tup)
del tup
print ("删除后的元组 tup : ")
print (tup)

#以上实例元组被删除后,输出变量会有异常信息,输出如下所示:
删除后的元组 tup :
Traceback (most recent call last):
File "test.py", line 8, in <module>
print (tup)
NameError: name 'tup' is not defined

元组运算符

与字符串一样,与列表相似,元组之间可以使用 + 号和 * 号进行运算。这就意味着他们可以组合和复制,运算后会生成一个新的元组

Python 表达式 结果 描述
len((1, 2, 3)) 3 计算元素个数
(1, 2, 3) + (4, 5, 6) (1, 2, 3, 4, 5, 6) 连接
(‘Hi!’,) * 4 (‘Hi!’, ‘Hi!’, ‘Hi!’, ‘Hi!’) 复制
3 in (1, 2, 3) True 元素是否存在
for x in (1, 2, 3): print (x,) 1 2 3 迭代

元组内置函数

序号 方法及描述 实例
1 len(tuple) 计算元组元素个数。 >>> tuple1 = ('Google', 'Runoob', 'Taobao') >>> len(tuple1) 3
2 max(tuple) 返回元组中元素最大值。 >>> tuple2 = ('5', '4', '8') >>> max(tuple2) '8'
3 min(tuple) 返回元组中元素最小值。 >>> tuple2 = ('5', '4', '8') >>> min(tuple2) '4'
4 tuple(iterable) 将可迭代系列转换为元组。 >>> list1= ['Google', 'Taobao', 'Runoob', 'Baidu'] >>> tuple1=tuple(list1) >>> tuple1 ('Google', 'Taobao', 'Runoob', 'Baidu')

元组元素不可变

所谓元组的不可变指的是元组所指向的内存中的内容不可变。

1
2
3
4
5
6
7
8
9
10
>>> tup = ('r', 'u', 'n', 'o', 'o', 'b')
>>> tup[0] = 'g' # 不支持修改元素
Traceback (most recent call last):
File "<stdin>", line 1, **in** <module>
TypeError: 'tuple' object does **not** support item assignment
>>> id(tup) # 查看内存地址
4440687904
>>> tup = (1,2,3)
>>> id(tup)
4441088800 # 内存地址不一样了

从以上实例可以看出,重新赋值的元组 tup,虽然元组名字一样,但实际上在内存上已经绑定到新的对象了,不是修改了原来的对象。

异常处理

什么是异常?

异常是一个事件,该事件会在程序执行过程中发生,影响了程序的正常执行。

  • 一般情况下,在Python无法正常处理程序时就会发生一个异常。

  • 异常是Python对象,表示一个错误。

  • 当Python脚本发生异常时我们需要捕获处理它,否则程序会终止执行。

有哪些异常?

python标准异常

异常名称 描述
BaseException 所有异常的基类
SystemExit 解释器请求退出
KeyboardInterrupt 用户中断执行(通常是输入^C)
Exception 常规错误的基类
StopIteration 迭代器没有更多的值
GeneratorExit 生成器(generator)发生异常来通知退出
StandardError 所有的内建标准异常的基类
ArithmeticError 所有数值计算错误的基类
FloatingPointError 浮点计算错误
OverflowError 数值运算超出最大限制
ZeroDivisionError 除(或取模)零 (所有数据类型)
AssertionError 断言语句失败
AttributeError 对象没有这个属性
EOFError 没有内建输入,到达EOF 标记
EnvironmentError 操作系统错误的基类
IOError 输入/输出操作失败
OSError 操作系统错误
WindowsError 系统调用失败
ImportError 导入模块/对象失败
LookupError 无效数据查询的基类
IndexError 序列中没有此索引(index)
KeyError 映射中没有这个键
MemoryError 内存溢出错误(对于Python 解释器不是致命的)
NameError 未声明/初始化对象 (没有属性)
UnboundLocalError 访问未初始化的本地变量
ReferenceError 弱引用(Weak reference)试图访问已经垃圾回收了的对象
RuntimeError 一般的运行时错误
NotImplementedError 尚未实现的方法
SyntaxError Python 语法错误
IndentationError 缩进错误
TabError Tab 和空格混用
SystemError 一般的解释器系统错误
TypeError 对类型无效的操作
ValueError 传入无效的参数
UnicodeError Unicode 相关的错误
UnicodeDecodeError Unicode 解码时的错误
UnicodeEncodeError Unicode 编码时错误
UnicodeTranslateError Unicode 转换时错误
Warning 警告的基类
DeprecationWarning 关于被弃用的特征的警告
FutureWarning 关于构造将来语义会有改变的警告
OverflowWarning 旧的关于自动提升为长整型(long)的警告
PendingDeprecationWarning 关于特性将会被废弃的警告
RuntimeWarning 可疑的运行时行为(runtime behavior)的警告
SyntaxWarning 可疑的语法的警告
UserWarning 用户代码生成的警告

如何处理异常?

python提供了两个非常重要的功能来处理python程序在运行中出现的异常和错误。可用该功能来调试python程序。

  • 异常处理
  • 断言(Assertions)

异常处理?

  • 捕捉异常可以使用try/except语句。

  • try/except语句用来检测try语句块中的错误,从而让except语句捕获异常信息并处理。

  • 如果不想在异常发生时结束程序,只需在try里捕获它即可。

语法

以下为简单的try….except…else的语法:

1
2
3
4
5
6
7
8
try:
<语句> #运行别的代码
except <名字>:
<语句> #如果在try部份引发了'name'异常
except <名字>,<数据>:
<语句> #如果引发了'name'异常,获得附加的数据
else:
<语句> #如果没有异常发生
try的工作原理

当开始一个try语句后,python就在当前程序的上下文中作标记,这样当异常出现时就可以回到这里,try子句先执行,接下来会发生什么依赖于执行时是否出现异常。以上面的代码为例:

  • 如果当try后的语句执行时发生异常,python就跳回到try并执行第一个匹配该异常的except子句,异常处理完毕,控制流就通过整个try语句(除非在处理异常时又引发新的异常)。
  • 如果在try后的语句里发生了异常,却没有匹配的except子句,异常将被递交到上层的try,或者到程序的最上层(这样将结束程序,并打印默认的出错信息)。
  • 如果在try子句执行时没有发生异常,python将执行else语句后的语句(如果有else的话),然后控制流通过整个try语句。
实例

下面是简单的例子,它打开一个文件,在该文件中的内容写入内容,但文件没有写入权限,发生了异常:

1
2
3
4
5
6
7
8
9
10
11
#!/usr/bin/python
# -*- coding: UTF-8 -*-

try:
fh = open("testfile", "w")
fh.write("这是一个测试文件,用于测试异常!!")
except IOError:
print "Error: 没有找到文件或读取文件失败"
else:
print "内容写入文件成功"
fh.close()

在执行代码前为了测试方便,我们可以先去掉 testfile 文件的写权限,命令如下:

1
chmod -w testfile

再执行以上代码:

1
2
$ python test.py 
Error: 没有找到文件或读取文件失败

except不带任何异常类型

不带任何异常类型使用except:

1
2
3
4
5
6
try:
正常的操作
except:
发生异常,执行这块代码
else:
如果没有异常执行这块代码
  • 以上方式能捕获所有的异常但不能识别异常;
except带多种异常类型

可以使用相同的except语句来处理多个异常信息,如下所示:

1
2
3
4
5
6
try:
正常的操作
except(Exception1[, Exception2[,...ExceptionN]]):
发生以上多个异常中的一个,执行这块代码
else:
如果没有异常执行这块代码

try-finally 语句

try-finally 语句无论是否发生异常都将执行最后的代码。

1
2
3
4
5
try:
<语句>
finally:
<语句> #退出try时总会执行
raise
实例
1
2
3
4
5
6
7
8
#!/usr/bin/python
# -*- coding: UTF-8 -*-

try:
fh = open("testfile", "w")
fh.write("这是一个测试文件,用于测试异常!!")
finally:
print "Error: 没有找到文件或读取文件失败"

如果打开的文件没有可写权限,输出如下所示:

1
2
$ python test.py 
Error: 没有找到文件或读取文件失败

同样的例子也可以写成如下方式:

1
2
3
4
5
6
7
8
9
10
11
12
#!/usr/bin/python
# -*- coding: UTF-8 -*-

try:
fh = open("testfile", "w")
try:
fh.write("这是一个测试文件,用于测试异常!!")
finally:
print "关闭文件"
fh.close()
except IOError:
print "Error: 没有找到文件或读取文件失败"
  • 当在try块中抛出一个异常,立即执行finally块代码。

  • finally块中的所有语句执行后,异常被再次触发,并执行except块代码。

  • 参数的内容不同于异常。


异常的参数是什么?

  • 一个异常可以带上参数,可作为输出的异常信息参数。

  • 可通过except语句来捕获异常的参数,如下所示:

1
2
3
4
try:
正常的操作
except ExceptionType, Argument:
在这输出 Argument 的值...
  • 变量接收的异常值通常包含在异常的语句中。在元组的表单中变量可以接收一个或者多个值。

  • 元组通常包含错误字符串,错误数字,错误位置。

实例

以下为单个异常的实例:

1
2
3
4
5
6
7
8
9
10
11
12
#!/usr/bin/python
# -*- coding: UTF-8 -*-

# 定义函数
def temp_convert(var):
try:
return int(var)
except ValueError, Argument:
print "参数没有包含数字\n", Argument

# 调用函数
temp_convert("xyz");

以上程序执行结果如下:

1
2
3
$ python test.py 
参数没有包含数字
invalid literal for int() with base 10: 'xyz'

如何自己触发异常?

我们可以使用raise语句自己触发异常,raise语句可以在try的if中。

raise语法格式如下:

1
raise [Exception [, args [, traceback]]]
  • 语句中 Exception 是异常的类型(例如,NameError)参数标准异常中任一种,args 是自已提供的异常参数。

  • 最后一个参数是可选的(在实践中很少使用),如果存在,是跟踪异常对象。

实例

一个异常可以是一个字符串,类或对象。 Python的内核提供的异常,大多数都是实例化的类,这是一个类的实例的参数。

定义一个异常非常简单,如下所示:

1
2
3
4
def functionName( level ):
if level < 1:
raise Exception("Invalid level!", level)
# 触发异常后,后面的代码就不会再执行

注意:为了能够捕获异常,”except”语句必须有用相同的异常来抛出类对象或者字符串。说白了就是except后面跟的要和try中自己raise的Exception名字一样。

例如我们捕获以上异常,”except”语句如下所示:

1
2
3
4
5
6
try:
正常逻辑
except Exception,err:
触发自定义异常
else:
其余代码

实例

1
2
3
4
5
6
7
8
9
10
11
12
13
14
#!/usr/bin/python
# -*- coding: UTF-8 -*-

# 定义函数
def mye( level ):
if level < 1:
raise Exception,"Invalid level!"
# 触发异常后,后面的代码就不会再执行
try:
mye(0) # 触发异常
except Exception,err:
print 1,err
else:
print 2

执行以上代码,输出结果为:

1
2
$ python test.py 
1 Invalid level!

如何自定义异常?

  • 通过创建一个新的异常类,程序可以命名它们自己的异常。异常应该是典型的继承自Exception的类,通过直接或间接的方式。

  • 以下为与RuntimeError相关的实例,实例中创建了一个类,基类为RuntimeError,用于在异常触发时输出更多的信息。

在try语句块中,用户自定义的异常后执行except块语句,变量 e 是用于创建Networkerror类的实例。

1
2
3
class Networkerror(RuntimeError):
def __init__(self, arg):
self.args = arg

在定义以上类后,可以触发该异常,如下所示:

1
2
3
4
try:
raise Networkerror("Bad hostname")
except Networkerror,e:
print e.args